diff -urP xmms-sid-0.8.0beta15/Makefile.am bmp-sid-0.8.0beta15.current/Makefile.am
--- xmms-sid-0.8.0beta15/Makefile.am	2005-11-09 20:15:10.000000000 +0100
+++ bmp-sid-0.8.0beta15.current/Makefile.am	2005-11-24 23:20:40.000000000 +0100
@@ -2,16 +2,17 @@
 ### Makefile.am for XMMS-SID
 ###
 # Require latest automake
-AUTOMAKE_OPTIONS = 1.7
+AUTOMAKE_OPTIONS = 1.9
 
-# Personal XMMS directory in user's home
-USERHOMEPREFIX = ~/.xmms/Plugins
+# Personal XMMS/BMP directory in user's home
+USERHOMEPREFIX = ~/.@PLAYER@/Plugins
 
 # All the rest of the distributed files
 EXTRA_DIST =				\
 	FAQ				\
 	BUGS				\
 	THANKS				\
+	BMP-SID				\
 	ChangeLog.old			\
 	bootstrap.sh			\
 	xmms-sid.glade			\
@@ -49,17 +50,41 @@
 ###
 ### Source targets
 ###
-# Generated libraries
-lib_LTLIBRARIES = libxmmssid.la
-
 # Generals
-AM_CFLAGS   = -W -Wall -D_REENTRANT @XMMS_CFLAGS@ @SIDPLAY1_INCLUDES@ @SIDPLAY2_INCLUDES@ @BUILDERS_INCLUDES@
+AM_CFLAGS   = -W -Wall -D_REENTRANT @PLAYER_CFLAGS@ @SIDPLAY1_INCLUDES@ @SIDPLAY2_INCLUDES@ @BUILDERS_INCLUDES@
 AM_CXXFLAGS = $(AM_CFLAGS)
 
-libxmmssid_la_LDFLAGS = -module -avoid-version @BUILDERS_LDFLAGS@
-libxmmssid_la_LIBADD  = @XMMS_LIBS@ @SIDPLAY1_LDADD@ @SIDPLAY2_LDADD@ @RESID_LDADD@ @HARDSID_LDADD@
+# Generated libraries
+
+if GOFORBMP
+
+lib_LTLIBRARIES = libbmpsid.la
+libbmpsid_la_LDFLAGS = -module -avoid-version @BUILDERS_LDFLAGS@
+libbmpsid_la_LIBADD  = @PLAYER_LIBS@ @SIDPLAY1_LDADD@ @SIDPLAY2_LDADD@ @RESID_LDADD@ @HARDSID_LDADD@
+libbmpsid_la_SOURCES =	\
+	src/xs_init.c					\
+	src/xs_about.c					\
+	src/xs_support.c	src/xs_support.h	\
+	src/xs_config.c		src/xs_config.h		\
+	src/xs_md5.c		src/xs_md5.h		\
+	src/xs_length.c		src/xs_length.h		\
+	src/xs_genui.c		src/xs_genui.h		\
+	src/xs_glade.c		src/xs_glade.h		\
+	src/xs_interface.c	src/xs_interface.h	\
+	src/xs_stil.c		src/xs_stil.h		\
+	src/xs_title.c		src/xs_title.h		\
+	src/xs_fileinfo.c	src/xs_fileinfo.h	\
+	src/xs_filter.c		src/xs_filter.h		\
+	src/xs_sidplay.h				\
+	src/xs_sidplay1.cc	src/xs_sidplay1.h	\
+	src/xs_sidplay2.cc	src/xs_sidplay2.h	\
+	src/xmms-sid.c		src/xmms-sid.h
+
+else
 
-# Plugin sources
+lib_LTLIBRARIES = libxmmssid.la
+libxmmssid_la_LDFLAGS = -module -avoid-version @BUILDERS_LDFLAGS@
+libxmmssid_la_LIBADD  = @PLAYER_LIBS@ @SIDPLAY1_LDADD@ @SIDPLAY2_LDADD@ @RESID_LDADD@ @HARDSID_LDADD@
 libxmmssid_la_SOURCES =	\
 	src/xs_init.c					\
 	src/xs_about.c					\
@@ -79,4 +104,6 @@
 	src/xs_sidplay2.cc	src/xs_sidplay2.h	\
 	src/xmms-sid.c		src/xmms-sid.h
 
+endif
+
 libxmmssiddir = $(pkgdatadir)
diff -urP xmms-sid-0.8.0beta15/configure.in bmp-sid-0.8.0beta15.current/configure.in
--- xmms-sid-0.8.0beta15/configure.in	2005-11-09 01:50:56.000000000 +0100
+++ bmp-sid-0.8.0beta15.current/configure.in	2005-11-24 23:20:44.000000000 +0100
@@ -48,9 +48,6 @@
 dnl *** Checks for generic libraries
 dnl ***
 AC_CHECK_HEADER([pthread.h],,AC_MSG_ERROR([[*** POSIX thread support not found. Strange, maybe you don't have some development packages installed?]]))
-AM_PATH_GLIB([1.2.5],,AC_MSG_ERROR([[*** GLib >= 1.2.5 not found. You either don't have GLib at all or your GLib is too old. Latest GLib can be found from Gtk+ homepages (http://www.gtk.org/)]]))
-AM_PATH_GTK([1.2.5],,AC_MSG_ERROR([[*** Gtk+ >= 1.2.5 not found. You either don't have Gtk+ at all or your Gtk+ is too old. Latest Gtk+ can be found from Gtk+ homepages (http://www.gtk.org/)]]), gthread)
-
 
 dnl ***
 dnl *** Checks for header files, types and functions
@@ -70,6 +67,80 @@
 AC_FUNC_STAT
 AC_CHECK_FUNCS([memset strcasecmp strerror])
 
+AC_ARG_ENABLE(bmp, [  --enable-bmpsid         build BMP plugin instead of XMMS plugin])
+
+if test "x$enable_bmpsid" = "xyes" ; then
+
+  AC_DEFINE(BUILD_FOR_BMP,[1],[If this macro is defined, a BMP plugin will be built instead of XMMS one.])
+  AC_DEFINE(HAVE_XMMSEXTRA)
+
+  AM_PATH_GLIB_2_0(2.4.0, , AC_MSG_ERROR([*** GLIB >= 2.4.0 not installed - please install first ***]))
+  AM_PATH_GTK_2_0(2.4.0, , AC_MSG_ERROR([*** GTK+ >= 2.4.0 not installed - please install first ***]))
+
+  PKG_CHECK_MODULES(BEEP, [ bmp >= 0.9.7], , AC_MSG_ERROR("**** You need the BEEP development files to compile this plugin ****"))
+  BEEP_INPUT_PLUGIN_DIR="`$PKG_CONFIG --variable=input_plugin_dir bmp`"
+
+  AC_SUBST(BEEP_INPUT_PLUGIN_DIR)
+
+  libdir=$BEEP_INPUT_PLUGIN_DIR
+  PLAYER=bmp
+
+  PLAYER_CFLAGS=$BEEP_CFLAGS
+  PLAYER_LIBS=$BEEP_LIBS
+
+  AM_CONDITIONAL(GOFORBMP, true)
+
+else
+
+  AM_PATH_GLIB([1.2.5],,AC_MSG_ERROR([[*** GLib >= 1.2.5 not found - please install first ***]]))
+  AM_PATH_GTK([1.2.5],,AC_MSG_ERROR([[*** Gtk+ >= 1.2.5 not found - please install first ***]]), gthread)
+
+  dnl ***
+  dnl *** Check XMMS version
+  dnl ***
+  AM_PATH_XMMS([1.2.0],, [
+    AC_MSG_ERROR([*** XMMS >= 1.2.0 not found. You need XMMS v1.2.0 or later to use XMMS-SID plugin.])
+  ])
+  libdir=$XMMS_INPUT_PLUGIN_DIR
+  PLAYER=xmms
+
+  XMMS_TEST_VERSION($XMMS_VERSION, 1.2.5, [
+    AC_DEFINE(HAVE_XMMSEXTRA)
+    OPT_XMMSEXTRA="yes"
+  ], [
+    OPT_XMMSEXTRA="no"
+  ])
+
+  dnl ***
+  dnl *** Song position patch check
+  dnl ***
+  AC_MSG_CHECKING([for song position patch])
+  tmp_CPPFLAGS=$CPPFLAGS
+  if test -d "$prefix" ;then
+    CPPFLAGS="$CPPFLAGS -I${prefix}/include"
+  fi
+  AC_EGREP_HEADER([set_song_position],[xmms/plugin.h],
+  [
+    OPT_SONGPOS="yes"
+    AC_DEFINE(HAVE_SONG_POSITION)
+    AC_MSG_RESULT([yes])
+  ],[
+    OPT_SONGPOS="no"
+    AC_MSG_RESULT([no])
+  ])
+  CPPFLAGS=$tmp_CPPFLAGS
+
+  PLAYER_CFLAGS=$XMMS_CFLAGS
+  PLAYER_LIBS=$XMMS_LIBS
+
+  AM_CONDITIONAL(GOFORBMP, false)
+
+fi
+
+AC_SUBST(PLAYER)
+AC_SUBST(PLAYER_CFLAGS)
+AC_SUBST(PLAYER_LIBS)
+
 
 dnl ***
 dnl *** libSIDPlay 1 options
@@ -200,44 +271,6 @@
 
 
 dnl ***
-dnl *** Song position patch check
-dnl ***
-AC_MSG_CHECKING([for song position patch])
-tmp_CPPFLAGS=$CPPFLAGS
-if test -d "$prefix" ;then
-  CPPFLAGS="$CPPFLAGS -I${prefix}/include"
-fi
-
-AC_EGREP_HEADER([set_song_position],[xmms/plugin.h],
-[
-OPT_SONGPOS="yes"
-AC_DEFINE(HAVE_SONG_POSITION)
-AC_MSG_RESULT([yes])
-],[
-OPT_SONGPOS="no"
-AC_MSG_RESULT([no])
-])
-
-CPPFLAGS=$tmp_CPPFLAGS
-
-
-dnl ***
-dnl *** Check XMMS version
-dnl ***
-AM_PATH_XMMS(1.2.0,, [
-AC_MSG_ERROR([*** XMMS >= 1.2.0 not found. You need XMMS v1.2.0 or later to use XMMS-SID plugin.])
-])
-libdir=$XMMS_INPUT_PLUGIN_DIR
-
-XMMS_TEST_VERSION($XMMS_VERSION, 1.2.5, [
-AC_DEFINE(HAVE_XMMSEXTRA)
-OPT_XMMSEXTRA="yes"
-], [
-OPT_XMMSEXTRA="no"
-])
-
-
-dnl ***
 dnl *** And finally, output the all generatable files!
 dnl ***
 AC_CONFIG_FILES([
@@ -250,9 +283,21 @@
 dnl ***
 dnl *** Show the result message
 dnl ***
+if test "x$PLAYER" = xbmp; then
 AC_MSG_RESULT([
 	XMMS-SID has been configured successfully:
 
+	Plugin to build               : BMP-SID
+	Installation directory        : $libdir
+	libSIDPlay 1 support          : $OPT_SIDPLAY1
+	libSIDPlay 2 support          : $OPT_SIDPLAY2
+		Included builders     : $xs_builders
+])
+else
+AC_MSG_RESULT([
+	XMMS-SID has been configured successfully:
+
+	Plugin to build               : XMMS-SID
 	Installation directory        : $libdir
 	XMMS >= v1.2.5 extra features : $OPT_XMMSEXTRA
 	Song-position patch           : $OPT_SONGPOS
@@ -260,3 +305,4 @@
 	libSIDPlay 2 support          : $OPT_SIDPLAY2
 		Included builders     : $xs_builders
 ])
+fi
